import os
import sys
from optparse import OptionParser
from rhev import *


# create connection
# ******************************************************
api = Connection('http://localhost:8080/api', 'mpastern@qa.lab.tlv.redhat.com', 'maiklp85')

try:
    api.ping()
except Error, e:
    sys.stderr.write('could not connect: %s\n' % str(e.detail))
    sys.exit(1)
# ******************************************************
cluster = api.get(schema.Cluster, name='Default_nfs')
if cluster is None:
    sys.stderr.write('error: cluster not found: %s\n' % 'Default_nfs')
    sys.exit(1)
    
template = api.get(schema.Template, name='Template2_nfs')
if template is None:
    sys.stderr.write('error: template not found: %s\n' % 'Template2_nfs')
    sys.exit(1)

network = api.get(schema.Network, base=cluster,
                        filter={'name': 'rhevm'})
if network is None:
    sys.stderr.write('error: network not found: %s\n' % 'rhevm')
    sys.exit(1)

# ******************************************************
try:    
    vm = api.get(schema, name='python_vm')
    vm = api.getall(schema.VM)
    if(vm is None):
        vm = schema.new(schema.VM, name='python_vm')
        vm.memory = 1024 * 1024**2
        vm.cluster = schema.ref(cluster)
        vm.template = schema.ref(template)
        vm = api.create(vm)

        nic = schema.new(schema.NIC)
        nic.name = 'eth0'
        nic.type = 'virtio'
        nic.network = schema.ref(network)
        
        #a1
        api.create(nic, base=vm)
        
        #a2
        vm.start()
        
# new property oriented sub-collection exposure
# ******************************************************        
    ######### new ##########
    networks = cluster.networks    
    disks = vm.disks
    nics = vm.nics
    cdroms = vm.cdroms
    snapshots = vm.snapshots
    tags = vm.tags
    statistics = vm.statistics
    
    datacenter = api.get(schema.DataCenter, name='aa')
    storagedomains = datacenter.storagedomains
    
#    permissions = api.getall(schema.Permission, base=cluster)            
#    permissions = cluster.permissions
    
    
#    print networks
#    cluster.networks.get()
#    cluster.networks.get({'name': opts.network})
    
#    vm.nics.get()    
#    vm.nics.add(nic)
#    vm.nics.get()    
#    vm.nics.update(nic)
#    vm.nics.delete(nic)
    ######### new ##########
    
    
#    vm.start()

#    disk = schema.new(schema.Disk)
#    disk.size = opts.disk * 1024**3
#    disk.format = 'cow'
#    disk.sparse = True
#    disk.interface = 'virtio'
#    api.create(disk, base=vm)

#    print 'created vm: "%s", with %dMB RAM, %dGB disk and 1 NIC' % \
#            (args[0], opts.memory, opts.disk)

# actions
# ****************************************************** 

except Error, e:
    sys.stderr.write('ERROR: %s\n' % str(e.detail))
    sys.exit(1)
